# HG changeset patch
# Node ID 076c5deb5665affd9685bdb98ee7b9d910604e22
# Parent  58687db710b539ed03c068461bbc27b443f2d205
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -34,6 +34,7 @@
 	'pidginnotifiable.c',
 	'pidginnotification.c',
 	'pidginnotificationaddcontact.c',
+	'pidginnotificationlink.c',
 	'pidginnotificationlist.c',
 	'pidginpluginsmenu.c',
 	'pidginpresenceicon.c',
@@ -81,6 +82,7 @@
 	'pidginnotifiable.h',
 	'pidginnotification.h',
 	'pidginnotificationaddcontact.h',
+	'pidginnotificationlink.h',
 	'pidginnotificationlist.h',
 	'pidginpluginsmenu.h',
 	'pidginpresenceicon.h',
diff --git a/pidgin/pidginnotificationlink.c b/pidgin/pidginnotificationlink.c
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationlink.c
@@ -0,0 +1,94 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#include <glib/gi18n-lib.h>
+
+#include <purple.h>
+
+#include "pidgin/pidginnotificationlink.h"
+
+struct _PidginNotificationLink {
+	PidginNotification parent;
+};
+
+G_DEFINE_FINAL_TYPE(PidginNotificationLink, pidgin_notification_link,
+                    PIDGIN_TYPE_NOTIFICATION)
+
+/******************************************************************************
+ * Actions
+ *****************************************************************************/
+static void
+pidgin_notification_link_open_uri(GtkWidget *self,
+                                  G_GNUC_UNUSED const char *action_name,
+                                  G_GNUC_UNUSED GVariant *parameter)
+{
+	PidginNotification *pidgin_notification = PIDGIN_NOTIFICATION(self);
+	PurpleNotification *purple_notification = NULL;
+	PurpleNotificationLink *link = NULL;
+	PurpleUi *ui = NULL;
+	const char *uri = NULL;
+
+	purple_notification = pidgin_notification_get_notification(pidgin_notification);
+	purple_notification_set_read(purple_notification, TRUE);
+
+	link = PURPLE_NOTIFICATION_LINK(purple_notification);
+	uri = purple_notification_link_get_link_uri(link);
+
+	ui = purple_core_get_ui();
+	purple_ui_open_uri(ui, uri, NULL, NULL, NULL);
+}
+
+/******************************************************************************
+ * GObject Implementation
+ *****************************************************************************/
+static void
+pidgin_notification_link_init(PidginNotificationLink *notification) {
+	gtk_widget_init_template(GTK_WIDGET(notification));
+}
+
+static void
+pidgin_notification_link_class_init(PidginNotificationLinkClass *klass) {
+	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
+
+	gtk_widget_class_set_template_from_resource(
+	    widget_class,
+	    "/im/pidgin/Pidgin3/notificationlink.ui"
+	);
+
+	gtk_widget_class_install_action(widget_class, "uri.open",
+	                                NULL,
+	                                pidgin_notification_link_open_uri);
+}
+
+/******************************************************************************
+ * API
+ *****************************************************************************/
+GtkWidget *
+pidgin_notification_link_new(PurpleNotification *notification) {
+	g_return_val_if_fail(PURPLE_IS_NOTIFICATION_LINK(notification),
+	                     NULL);
+
+	return g_object_new(
+		PIDGIN_TYPE_NOTIFICATION_LINK,
+		"notification", notification,
+		NULL);
+}
diff --git a/pidgin/pidginnotificationlink.h b/pidgin/pidginnotificationlink.h
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationlink.h
@@ -0,0 +1,73 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#if !defined(PIDGIN_GLOBAL_HEADER_INSIDE) && !defined(PIDGIN_COMPILATION)
+# error "only <pidgin.h> may be included directly"
+#endif
+
+#ifndef PIDGIN_NOTIFICATION_LINK_H
+#define PIDGIN_NOTIFICATION_LINK_H
+
+#include <glib.h>
+
+#include <gtk/gtk.h>
+
+#include <purple.h>
+
+#include "pidginnotification.h"
+#include "pidginversion.h"
+
+G_BEGIN_DECLS
+
+/**
+ * PidginNotificationLink:
+ *
+ * #PidginNotificationLink is a widget that displays
+ * notifications from [class@Purple.NotificationManager] for
+ * [class@Purple.NotificationLink].
+ *
+ * Since: 3.0
+ */
+
+#define PIDGIN_TYPE_NOTIFICATION_LINK (pidgin_notification_link_get_type())
+
+PIDGIN_AVAILABLE_IN_3_0
+G_DECLARE_FINAL_TYPE(PidginNotificationLink, pidgin_notification_link,
+                     PIDGIN, NOTIFICATION_LINK, PidginNotification)
+
+/**
+ * pidgin_notification_link_new:
+ * @notification: A [class@Purple.Notification] to display.
+ *
+ * Creates a new #PidginNotificationLink instance that will display
+ * @notification.
+ *
+ * Returns: (transfer full): The new #PidginNotificationLink instance.
+ *
+ * Since: 3.0
+ */
+PIDGIN_AVAILABLE_IN_3_0
+GtkWidget *pidgin_notification_link_new(PurpleNotification *notification);
+
+G_END_DECLS
+
+#endif /* PIDGIN_NOTIFICATION_LINK_H */
diff --git a/pidgin/pidginnotificationlist.c b/pidgin/pidginnotificationlist.c
--- a/pidgin/pidginnotificationlist.c
+++ b/pidgin/pidginnotificationlist.c
@@ -29,6 +29,7 @@
 #include "pidginnotifiable.h"
 #include "pidginnotification.h"
 #include "pidginnotificationaddcontact.h"
+#include "pidginnotificationlink.h"
 
 enum {
 	PROP_0,
@@ -105,6 +106,8 @@
 
 	if(PURPLE_IS_NOTIFICATION_ADD_CONTACT(notification)) {
 		widget = pidgin_notification_add_contact_new(notification);
+	} else if(PURPLE_IS_NOTIFICATION_LINK(notification)) {
+		widget = pidgin_notification_link_new(notification);
 	} else {
 		widget = pidgin_notification_new(notification);
 	}
diff --git a/pidgin/resources/notificationlink.ui b/pidgin/resources/notificationlink.ui
new file mode 100644
--- /dev/null
+++ b/pidgin/resources/notificationlink.ui
@@ -0,0 +1,47 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+Pidgin - Internet Messenger
+Copyright (C) Pidgin Developers <devel@pidgin.im>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, see <https://www.gnu.org/licenses/>.
+
+-->
+<interface>
+  <requires lib="gtk" version="4.0"/>
+  <!-- interface-license-type gplv2 -->
+  <!-- interface-name Pidgin -->
+  <!-- interface-description Internet Messenger -->
+  <!-- interface-copyright Pidgin Developers <devel@pidgin.im> -->
+  <template class="PidginNotificationLink" parent="PidginNotification">
+    <property name="child">
+      <object class="GtkBox">
+        <property name="orientation">horizontal</property>
+        <property name="spacing">6</property>
+        <child>
+          <object class="GtkButton" id="add">
+            <property name="label" translatable="1">Open Link</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">uri.open</property>
+            <style>
+              <class name="suggested-action"/>
+            </style>
+          </object>
+        </child>
+      </object>
+    </property>
+  </template>
+</interface>
diff --git a/pidgin/resources/pidgin.gresource.xml b/pidgin/resources/pidgin.gresource.xml
--- a/pidgin/resources/pidgin.gresource.xml
+++ b/pidgin/resources/pidgin.gresource.xml
@@ -37,6 +37,7 @@
     <file compressed="true" preprocess="xml-stripblanks">infopane.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notification.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationaddcontact.ui</file>
+    <file compressed="true" preprocess="xml-stripblanks">notificationlink.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationlist.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">presenceicon.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">typinglabel.ui</file>
